// TimeTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TimeTest.h"
#include "TimeTestDlg.h"
#include "ET199_32.h"
#include "RSAEnc.h"

#pragma comment(lib,"ET199_32S.lib")
#pragma comment(lib,"RSAEnc.lib")

DWORD g_dwRet=0;
DWORD g_dwCount=0;
ET_CONTEXT *g_pContext=NULL;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//
void FlipBuffer(unsigned char* pBuf, unsigned long ulLen)
{
	unsigned char ucTemp;
	for(unsigned long i = 0; i < ulLen >> 1; ++i)
	{
		ucTemp = pBuf[i];
		pBuf[i] = pBuf[ulLen - i - 1];
		pBuf[ulLen - i - 1] = ucTemp;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTimeTestDlg dialog

CTimeTestDlg::CTimeTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTimeTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTimeTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTimeTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTimeTestDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTimeTestDlg, CDialog)
	//{{AFX_MSG_MAP(CTimeTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTimeTestDlg message handlers

BOOL CTimeTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	
	//öET199
	g_dwRet=ETEnum(NULL,&g_dwCount);

	if(g_dwRet != ET_E_INSUFFICIENT_BUFFER && g_dwRet)
		return FALSE;

	//ڴڴ洢CONTEXTṹ
	g_pContext = new ET_CONTEXT[g_dwCount];

	//0
	memset(g_pContext,0,sizeof(ET_CONTEXT)*g_dwCount);

	//ʹ÷Ļ½ö
	g_dwRet=ETEnum(g_pContext,&g_dwCount);
	if(g_dwRet)
	{
		delete [] g_pContext;
		return FALSE;
	}

	//ET199
	g_dwRet = ETOpen(&g_pContext[0]);
	if(g_dwRet)
	{
		delete [] g_pContext;
		return FALSE;
	}

	//ִпִļǰִ֤ļĿ¼ûPIN
	g_dwRet = ETVerifyPin(&g_pContext[0], ET_DEFAULT_USER_PIN, ET_USER_PIN_LEN, ET_USER_PIN);
	if(g_dwRet)
	{
		delete [] g_pContext;
		return FALSE;
	}

	//ִET199еĿִļ0001ǰĻʱ뵽ִļ0001
	char pbOut[256] = {0};
	DWORD dwOutLen = 0;

	CTime t = CTime::GetCurrentTime(); 
	time_t lCurrentTime = t.GetTime();
	//time_t lCurrentTime1 = lCurrentTime;
	
	//C51PC˳෴Ҫȵߵ˳
	FlipBuffer((BYTE*)&lCurrentTime, sizeof(time_t));

	g_dwRet = ETExecute(&g_pContext[0],"0001", &lCurrentTime, 4, pbOut, 256, &dwOutLen);
	if(g_dwRet)
	{
		delete [] g_pContext;
		return FALSE;
	}	

	if(dwOutLen != 128)
	{
		delete [] g_pContext;
		return FALSE;
	}

	//мĽ״̬
	/*BYTE pbTemp[256] = {0};
	DWORD s1,s2,s3;
	memcpy(pbTemp, pbOut, 256);
	
	FlipBuffer(pbTemp, 4);
	memcpy(&s1, pbTemp, 4);

	FlipBuffer(pbTemp+4, 4);
	memcpy(&s2, pbTemp+4, 4);

	FlipBuffer(pbTemp+8, 4);
	memcpy(&s3, pbTemp+8, 4);

	char cTemp[1024] = {0};
	sprintf(cTemp, "%d, StarFile:%d, Star:%d, EndFile:%d", lCurrentTime1, s1,s2,s3);
	AfxMessageBox(cTemp);
	*/

	//ET199ʹRSA˽ԿܺʹRSAԿ

	//Կnֵ128ֽ
	//1002.pubļУ
	//ǰ4ֽڣ0-3ǹԿȣ00 00 00 80Ϊ128ֽ
	//128ֽڣ4131ΪԿnֱֵӷŵ
	//ٺ4ֽڣ132-135Ϊֵ
	//4ֽڣ136139ǹԿeֵ00 01 00 01Ϊ65537ҪעʾеRSAData.dllֻ֧eΪ65537ֵ֧
	BYTE pbModulus[128] = {
		0xB4, 0x51, 0x64, 0x1C, 0x39, 0xC7, 0x8F, 0x51, 0xB5, 0x36, 0x30, 0xA1, 0x7F, 0xBE, 0x70, 0xB0,
		0xBE, 0x3A, 0x87, 0x3F, 0x78, 0x50, 0x20, 0x57, 0xFD, 0xDB, 0xD7, 0x6B, 0x6E, 0x4B, 0x9E, 0x3A,
		0xE7, 0x8A, 0xA5, 0x8F, 0x7A, 0x51, 0x22, 0x4A, 0xC3, 0x64, 0x5D, 0x84, 0xA7, 0xB2, 0x10, 0xE1,
		0x1B, 0x32, 0x67, 0x95, 0x1F, 0xB4, 0x62, 0x71, 0x8A, 0xA6, 0x3D, 0x35, 0x9B, 0x52, 0xC5, 0x4A,
		0x2A, 0xA2, 0x86, 0xB2, 0x55, 0x13, 0x90, 0xDB, 0x5A, 0x0E, 0xE0, 0xA4, 0x71, 0x0C, 0x09, 0xF6,
		0x3B, 0x21, 0x95, 0x35, 0x29, 0xC4, 0x7E, 0xF8, 0x3B, 0xA9, 0x6C, 0x4E, 0x61, 0xC8, 0x84, 0x79,
		0xDC, 0x8F, 0x5F, 0x0E, 0x1B, 0xE2, 0xF8, 0x72, 0xC2, 0x46, 0x25, 0x21, 0x03, 0xBE, 0x1A, 0x80,
		0x6A, 0xAA, 0x17, 0x37, 0xCE, 0x19, 0x9D, 0x14, 0x49, 0x98, 0xE2, 0x98, 0x16, 0x3C, 0x3A, 0xB9	
	};

	//ʹùԿн
	//RSAData˵
	//һԿnָ
	//ڶԿĳȣֻ51210242048ʹ1024
	//ΪģΪ
	//ĸݳȣ1024ĹԿֻ128
	//Ҫرע⣬ӿֹֻ֧ԿeֵΪ65537֧eֵĹԿ
	g_dwRet = RSAData(pbModulus,1024,(BYTE*)pbOut,128);
	if(g_dwRet == 0)
	{
		//ܺ
		GetDlgItem(IDC_BUTTON1)->SetWindowText(pbOut);
	}


	

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTimeTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTimeTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTimeTestDlg::OnQueryDragIcon()
{

	return (HCURSOR) m_hIcon;
}

void CTimeTestDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	if(g_pContext)
	{
		ETClose(&g_pContext[0]);
		delete [] g_pContext;
	}

	
	CDialog::OnClose();
}
